﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using System.Windows.Input;
using Xamarin.Forms;

namespace BindingValueDemo
{
   public class MyBillViewModel
    {
        public ICommand GetIdCommand { protected set; get; }
        public ObservableCollection<Bill> Bills { get; set; }
        public INavigation Navigation { get; set; }

        public MyBillViewModel(INavigation navigation)
        {
            this.Navigation = navigation;
            Bills = new ObservableCollection<Bill>();
            Bills.Add(new Bill { InvoiceDate = "2020/2/21", InvoiceNumber = "1" });
            Bills.Add(new Bill { InvoiceDate = "2020/2/22", InvoiceNumber = "2" });
            Bills.Add(new Bill { InvoiceDate = "2020/2/23", InvoiceNumber = "3" });
            Bills.Add(new Bill { InvoiceDate = "2020/2/24", InvoiceNumber = "4" });
            Bills.Add(new Bill { InvoiceDate = "2020/2/25", InvoiceNumber = "5" });
            Bills.Add(new Bill { InvoiceDate = "2020/2/26", InvoiceNumber = "6" });
            Bills.Add(new Bill { InvoiceDate = "2020/2/27", InvoiceNumber = "7" });


            //GetIdCommand = new Command<Bill>(async (key) => {
            //    Bill bill=(Bill)key;
            //    await Navigation.PushAsync(new Page2(bill));
                
            //});

            GetIdCommand = new Command<Bill>(
              execute: (Bill item) =>
              {
                  Console.WriteLine("doCheckin() executes: " + item.InvoiceDate);
              },
                    // some logic and async work
               
          canExecute: (Bill item) =>
          {
              if (item != null)
              {
                  Console.WriteLine("doCheckin() canExecute return" + item.InvoiceNumber);
              }
              else {

                  Console.WriteLine("canExecute() item is empty" );
              }
             // 
              return true; //some logic 
            }
              );
        }
    }
}
